from socket import gethostname
DEFAULT_PORT = 8030
DEFAULT_HOST = gethostname()

class ServerDef:
  def __init__(self):
    self.port        = None
    self.localBase   = None
    self.serverDir   = None
    self.baseUrl     = None
    self.title       = None
    self.services    = []
    self.serviceName = None
    self.workspaces  = []
    self.sources     = []
    self.extensions  = []

  def service(self, name, url):
    self.services.append((name, url))

  def workspace(self, type, *args):
    self.workspaces.append((type, args))

  def source(self, type, label, *args):
    self.sources.append((type, label, args))

  def extend(self, type, *args):
    self.extensions.append((type, args))

  def validate(self):
    if self.port == None:
      self.port = DEFAULT_PORT
    if self.localBase == None:
      self.localBase = '%s:%d' % (DEFAULT_HOST, self.port)
    elif self.localBase.find(':') == -1:
      self.localBase = '%s:%d' % (self.localBase, self.port)
    if self.title == None:
      self.title = "CMS monitoring"

    if self.serverDir == None:
      return "server.serverDir not set"
    if self.baseUrl == None:
      return "server.baseUrl not set"
    if len(self.services) == 0:
      return "no services added with server.service()"
    if self.serviceName == None:
      return "server.serviceName not set"
    if len(self.workspaces) == 0:
      return "no workspaces added with server.workspace()"
    if len(self.sources) == 0:
      return "no sources added with server.source()"
    return None
