#!/usr/bin/env python

#import os, re, time, urlparse, urllib, urllib2
from GuiPlot import *
#from GuiUtils import _logerrc, _logwarn, _loginfo, natsorted, thousands, timeseries
#from cherrypy import expose, HTTPError, tree, response, engine, thread_data, log
#from cherrypy.lib.static import serve_file
#from GuiUtils import natsorted,thousands,timeseries
from cherrypy import HTTPError, engine
from threading import Thread, Lock
from copy import deepcopy, copy
#from calendar import timegm
import time, datetime
import logging
import random
import urllib,urllib2
import socket
import re
from xml.dom.minidom import parseString

class ProdmonWorkspace:
  """
  Main production monitoring workspace class.
  Handles the current front end state, context,
  recent plots etc.
  """
  sessiondef = {'prodmon.view':'summary'}
  maxrecent = 5
  class ProdmonView:
    def __init__(self,workspace):
      self.workspace = workspace
    def _sessionState(self, session):
      no_upload = ('recent-opts',)
      view = session['prodmon.view']
      view_no_upload = ['prodmon.%s.%s' % (view,nop) for nop in no_upload]
      
      keys = ["%r:%r" % (key.replace('prodmon.%s.'%(view),''),session[key]) for key in session.keys() if (key.startswith('prodmon.%s.'%(view)) and not (key in view_no_upload))]
      state_extra = self._stateHook(session)
      if state_extra:
        keys.extend(state_extra)
      keystr = ','.join(keys)
      return "{kind: '%s', version: 0, %s}" % (self.pluginname,keystr)
    def _sessionTyping(self,session,*args,**kwargs):
      self.gui._saveSession(session)
      return self._state(session)
    def _graphLabel(self,session):
      return ''
    def _sessionView(self,session,*args,**kwargs):
      pass
    def _stateHook(self,session):
      return None
  
  class ProdmonSummary(ProdmonView):
    label="summary"
    pluginname="ProdmonSummary"
    name="Summary"
    viewdef={}
    def _stateHook(self,session):
      stats = self.workspace.source.getStatsSummary()
      keys = ['top5site:%r' % self.workspace.source.summaryList('site'),'top5wf:%r' % self.workspace.source.summaryList('wf')]
      keys.extend(['%r:%r' % (k,v) for k,v in stats.iteritems()])
      return keys
  class ProdmonSiteMultiple(ProdmonView):
    label="site-multi"
    pluginname="ProdmonSiteMultiple"
    name="Site (Multiple)"
    preset=[]
    viewdef={'prodmon.site-multi.preset':[],
         'prodmon.site-multi.what':'evts_read_any',
         'prodmon.site-multi.job':'Any',
         'prodmon.site-multi.graph':'bar',
         'prodmon.site-multi.regex':'null',
         'prodmon.site-multi.starttime':'',
         'prodmon.site-multi.endtime':'',
         'prodmon.site-multi.group':'null',
         'prodmon.site-multi.forceplot':'true'}
    def _graphLabel(self,session):
      return ''
  class ProdmonSiteSingle(ProdmonView):
    label="site-single"
    pluginname="ProdmonSiteSingle"
    name="Site (Single)"
    preset=[]
    viewdef={'prodmon.site-single.preset':[],
         'prodmon.site-single.what':'evts_read_any',
         'prodmon.site-single.job':'Any',
         'prodmon.site-single.graph':'bar',
         'prodmon.site-single.starttime':'',
         'prodmon.site-single.endtime':'',
    #     'prodmon.site-single.site':'',
         'prodmon.site-single.group':'null',
         'prodmon.site-single.forceplot':'false'}
    def _sessionTyping(self,session,*args,**kwargs):
      pass
    def _graphLabel(self,session):
      return ''
    def _sessionView(self,session,*args,**kwargs):
      if 'site' in kwargs:
        session['prodmon.site-single.autocomplete']=[kwargs['site']]
        session['prodmon.forceplot']='true'
  class ProdmonWFMultiple(ProdmonView):
    label="wf-multi"
    pluginname="ProdmonWFMultiple"
    name="Workflow (Multiple)"
    preset=[]
    viewdef={'prodmon.wf-multi.preset':[],
         'prodmon.wf-multi.what':'evts_read_any',
         'prodmon.wf-multi.job':'Any',
         'prodmon.wf-multi.graph':'bar',
         'prodmon.wf-multi.regex':'null',
         'prodmon.wf-multi.starttime':'',
         'prodmon.wf-multi.endtime':'',
         'prodmon.wf-multi.group':'null',
         'prodmon.wf-multi.forceplot':'true'}
    def _graphLabel(self,session):
      return ''
  class ProdmonWFSingle(ProdmonView):
    label="wf-single"
    pluginname="ProdmonWFSingle"
    name="Workflow (Single)"
    preset=[]
    viewdef={'prodmon.wf-single.preset':[],
         'prodmon.wf-single.what':'evts_read_any',
         'prodmon.wf-single.job':'Any',
         'prodmon.wf-single.graph':'bar',
         'prodmon.wf-single.starttime':'',
         'prodmon.wf-single.endtime':'',
    #     'prodmon.wf-single.wf':'',
         'prodmon.wf-single.group':'null',
         'prodmon.wf-single.forceplot':'false'}
    def _sessionTyping(self,session,*args,**kwargs):
      pass
    def _graphLabel(self,session):
      return ''
    def _sessionView(self,session,*args,**kwargs):
      if 'wf' in kwargs:
        session['prodmon.wf-single.autocomplete']=[kwargs['wf']]
        session['prodmon.forceplot']='true'
  
  def __init__(self,gui,name,*args):
    """
    Create a new ProdmonWorkspace instance. Note that we need to find ProdmonSource in the server
    source list, or we'll exit ingloriously. 
    
    TODO: good mechanism for finding sources
    TODO: SiteDB source integration
    TODO: ProdRequest integration
    TODO: Workspace base class
    
    """
    gui._addJSFragment("%s/gui-overview.js" % gui.contentpath)
    gui._addJSFragment("%s/gui-prodmon.js" % gui.contentpath)
    self.gui = gui
    self.name = name
    self.views=[ProdmonWorkspace.ProdmonSummary(self),ProdmonWorkspace.ProdmonSiteMultiple(self),ProdmonWorkspace.ProdmonSiteSingle(self),ProdmonWorkspace.ProdmonWFMultiple(self),ProdmonWorkspace.ProdmonWFSingle(self)]
    self.source = None
    for s in gui.sources:
      if s.plothook=='prodmon':
        self.source = s
    if self.source==None:
      raise Exception, "PW: Failed to find prodmon source. Fatal."
  
  
  def initialiseSession(self,session):
    """
    Called when session is created on the server. Populate the sessiondict from sessiondef.
    """
    for key,value in ProdmonWorkspace.sessiondef.iteritems():
      if key not in session:
        session[key]=deepcopy(value)
  
  def start(self,session,**kwargs):
    """
    Called when session lands on this workspace. Nothing to do here.
    """
    pass
  
  def sessionView(self,session,*args,**kwargs):
    """
    Called when a session navigates to a new view. Checks the view exists, then populates the sessiondict with the entries from the viewdef.
    """
    name = kwargs.get('name', None)
    if not isinstance(name, str):
      raise HTTPError(500, "Invalid name parameter")
    view = self._getView(name)
    for key,value in view.viewdef.iteritems():
      if key not in session:
        session[key]=deepcopy(value)
    view._sessionView(session,*args,**kwargs)
    session['prodmon.view'] = view.label
    self.gui._saveSession(session)
    return self._state(session)
  
  def _getView(self,label):
    """
    Helper function to resolve the current view object.
    """
    view = self.views[0]
    for v in self.views:
      if v.label == label:
        view = v
        break
    return view
  
  def _state(self,session):
    view = self._getView(session['prodmon.view'])
    self.gui._noResponseCaching()
    return ("([{kind: 'AutoUpdate', interval: %d, stamp: %d},"
          + "{kind: 'OverviewHeader', workspace: '%s', workspaces: [%s],"
          + " view: '%s', views: [%s]},"
          + "%s])") \
          % (300,
           self.gui.stamp,
           self.name,
           ",".join("{title: '%s', label: '%s'}"
                % (x.name, x.name.lower()) for x in self.gui.workspaces),
                view.name,
                ",".join("{title: '%s', label: '%s'}"
                   % (x.name, x.label) for x in self.views),
                   view._sessionState(session))
  
  def sessionState(self,session,*args,**kwargs):
    """
    Exposed method for _state.
    """  
    return self._state(session)
  
  def sessionResetWorkspace(self,session,*args,**kwargs):
    self.initialiseSession(session)
    self.gui._saveSession(session)
    return self._state(session) 
  
  def _checkRecent(self,session):
    """
    Check if the current view state is the same as any in the recent-opts list.
    If not, add an entry to the list.
    Also trim the list if it exceeds the allowable length.
    """
    view = session['prodmon.view']
    if (not 'prodmon.%s.recent' % (view) in session or not 'prodmon.%s.recent-opts' % (view) in session):
      session['prodmon.%s.recent-opts' % (view)]=[]
      session['prodmon.%s.recent' % (view)]=[]
    
    #awkward race condition here
    #if we check for excess length beforehand, we may trim the list and then insert nothing
    #if we check for excess length afterwards we may delete the entry we just found to exist and thus didn't replace
    if len(session['prodmon.%s.recent' % (view)])>ProdmonWorkspace.maxrecent:
      session['prodmon.%s.recent' % (view)].pop(0)
    if len(session['prodmon.%s.recent-opts' % (view)])>ProdmonWorkspace.maxrecent:
      session['prodmon.%s.recent-opts' % (view)].pop(0)
    
    #see if any of the entries match the current sessiondef - in which case set found
    recent =  self._graphLabel(session)
    found = False
    for i,r in enumerate(session['prodmon.%s.recent-opts' % (view)]):
      match = True
      for o in r:
        if not session.get('prodmon.%s.%s' % (view,o),'')==r.get(o,''):
          match = False
          break
      if match:
        found = True
        break
    
    
    
    #if we didn't find a match, add the current state to the recent-opts list
    if not found:
      recent_opts={}
      for key in session:
        if key.startswith('prodmon.%s.'%(view)):
          if not (key.startswith('prodmon.%s.recent'%(view)) or key.startswith('prodmon.%s.preset'%(view))):
            recent_opts[key]=deepcopy(session[key])
      session['prodmon.%s.recent-opts' % (view)].append(recent_opts)
      session['prodmon.%s.recent' % (view)].append(recent)
      
    
        
    
  
  def sessionGraph(self,session,*args,**kwargs):
    """
    Update one of the parameters (what, job_type, start/endtime, regex, graph type)
    Add the new parameter set to the recent plots list.
    """
    view = session['prodmon.view']
    session['prodmon.forceplot']='true'
    for s in ('what','job','starttime','endtime','regex','graph','group'):
      if s in kwargs and kwargs[s]:
        session['prodmon.%s.%s' % (view,s)]=kwargs[s]
    self._checkRecent(session)
    
    self.gui._saveSession(session)
    return self._state(session)
  
  def _graphLabel(self,session):
    """
    Converts as many elements from the session as it understands
    into a meaningful string describing the plot, for the recent function.
    TODO: delegate this to view?
    """
    view = session['prodmon.view']
    get = lambda x: session.get('prodmon.%s.%s' % (view,x),'')
    start = "(%s) %s" % (ProdmonSource.params['plot'][get('graph')],ProdmonSource.params['what'][get('what')])
    if (not get('job')=='Any'):
      start += ' (%s jobs)' % (ProdmonSource.params['job_type'][get('job')])
    group=''
    if (view=='site-multi' or view=='wf-single') and not (get('group')=='' or get('group')=='null'):
      group = ' group by %s' % (ProdmonSource.groups['site'][get('group')])
    if (view=='wf-multi' or view=='site-single') and not (get('group')=='' or get('group')=='null'):
      group = ' group by %s' % (ProdmonSource.groups['wf'][get('group')])
    start+=group  
    if view=='site-single':
      return "%s for site %s" % (start,get('site'))
    if view=='wf-single':
      return "%s for workflow %s" % (start,get('wf'))
    if not (get('regex')=='' or get('regex')=='null'):
      return "%s, matching %s" % (start,get('regex'))
    return start
    
  def sessionPlot(self,session,*args,**kwargs):
    """
    Called to force plotting.
    """
    session['prodmon.forceplot']='true'
    self.gui._saveSession(session)
    return self._state(session)
  
  def sessionRecent(self,session,*args,**kwargs):
    """
    Called when clicking on a recent session link to set all the params appropriately.
    """
    view = session['prodmon.view']
    if 'n' in kwargs and kwargs['n'].isdigit():
      n = int(kwargs['n'])
      if 'prodmon.%s.recent-opts'%(view) in session:
        recent_opts = session['prodmon.%s.recent-opts'%(view)]
        for key,value in recent_opts[n].iteritems():
          session[key]=value
        session['prodmon.forceplot']='true'
    self.gui._saveSession(session)
    return self._state(session)
  
  def sessionPreset(self,session,*args,**kwargs):
    """
    Called to summon a preset from the list stored in the view classes
    """
    view = session['prodmon.view']
    viewobj = self._getView(view)
    if 'n' in kwargs and kwargs['n'].isdigit():
      n = int(kwargs['n'])
      if n<len(viewobj.preset):
        for key,value in viewobj.preset[n].iteritems():
          session[key]=value
        session['prodmon.forceplot']='true'
    self.gui._saveSession(session)
    return self._state(session)
  
  def sessionTyping(self,session,*args,**kwargs):
    """
    Called when typing in process for wf/site selection.
    TODO: delegate this to view?
    """
    view = session['prodmon.view']
    session['prodmon.forceplot']='false'
    if view=='site-single':
      session['prodmon.%s.site' % (view)]=''
    if view=='wf-single':
      session['prodmon.%s.wf' % (view)]=''
    if 'text' in kwargs and kwargs['text']:
      text = kwargs['text']
      
      autolist = []
      if view=='site-single':
        autolist = self.source.getSiteList(lambda x: x.lower().find(text.lower())!=-1)
      if view=='wf-single':
        autolist = self.source.getWFList(lambda x: x.lower().find(text.lower())!=-1)
      
      session['prodmon.%s.autocomplete' % (view)]=list(autolist)
      if len(autolist)==1:
        if view=='site-single':
          session['prodmon.%s.site' % (view)]=autolist[0]
          session['prodmon.forceplot']='true'
        if view=='wf-single':
          session['prodmon.%s.wf' % (view)]=autolist[0]
          session['prodmon.forceplot']='true'
      
    self.gui._saveSession(session)
    return self._state(session)
  

class ProdmonSource:
  url = 'http://dashb-cmspa.cern.ch/dashboard/request.py/PAquery?'
  plothook = "prodmon"
  params = {}
  params['what'] = {'jobs_any' : 'Jobs', 'evts_read_any' : 'Events Read',
                   'time_any' : 'Time','time_by_span' : 'Batch Slots',
                   'CMSSW_fail_codes' : 'Exit Code', 
                   'jobs_success_rates' : 'Job Quality',
                   'event_written_any' : 'Events Written'}
  params['sortby'] = {'site' : 'Site', 'prod_team' : 'Production Team',
                       'wf' : 'Workflow', 'dts' : 'Dataset', 'exit_code' : 'Exit code',
                       'prod_agent' : 'Production Agent'}
  params['plot'] = {'bar': 'Bar', 'pie':'Pie', 'cumulative':'Cumulative'}
  params['job_type'] = {'Merge': 'Merge', 'Any': 'Merge and Processing', 'Processing': 'Processing'}
  types={'pdf':'application/pdf','ps':'application/postscript','eps':'application/postscript','png':'image/png','svg':  'image/svg+xml','json':'text/plain'}
  sitelist = ('T0_CH_CERN', 'T1_CH_CERN', 'T1_DE_FZK', 'T1_ES_PIC', 'T1_FR_CCIN2P3', 'T1_IT_CNAF', 'T1_TW_ASGC', 'T1_UK_RAL', 'T1_US_FNAL',
         'T2_AT_Vienna', 'T2_BE_IIHE', 'T2_BE_UCL', 'T2_BR_SPRACE', 'T2_BR_UERJ', 'T2_CH_CAF', 'T2_CH_CSCS', 'T2_CN_Beijing',
          'T2_DE_DESY', 'T2_DE_RWTH', 'T2_EE_Estonia', 'T2_ES_CIEMAT', 'T2_ES_IFCA', 'T2_FI_HIP', 'T2_FR_CCIN2P3', 'T2_FR_GRIF_IRFU',
           'T2_FR_GRIF_LAL', 'T2_FR_GRIF_LLR', 'T2_FR_GRIF_LPNHE', 'T2_FR_IPHC', 'T2_HU_Budapest', 'T2_IN_TIFR', 'T2_IT_Bari',
            'T2_IT_Legnaro', 'T2_IT_Pisa', 'T2_IT_Rome', 'T2_KR_KNU', 'T2_PL_Warsaw', 'T2_PT_LIP_Coimbra', 'T2_PT_LIP_Lisbon',
             'T2_RU_IHEP', 'T2_RU_INR', 'T2_RU_ITEP', 'T2_RU_JINR', 'T2_RU_PNPI', 'T2_RU_RRC_KI', 'T2_RU_SINP', 'T2_TR_METU',
              'T2_TR_ULAKBIM', 'T2_TW_Taiwan', 'T2_UA_KIPT', 'T2_UK_London_Brunel', 'T2_UK_London_IC','T2_UK_London_Imperial', 'T2_UK_SGrid_Bristol','T2_UK_SouthGrid_Bristol',
               'T2_UK_SGrid_RALPP','T2_UK_SouthGrid_RALPP', 'T2_US_Caltech', 'T2_US_Florida', 'T2_US_MIT', 'T2_US_Nebraska', 'T2_US_Purdue', 'T2_US_UCSD',
                'T2_US_Wisconsin', 'T3_UK_London_QMUL', 'T3_UK_London_RHUL', 'T3_UK_London_UCL', 'T3_UK_ScotGrid_ECDF', 'T3_CH_PSI',
                 'T3_CN_PKU', 'T3_CO_Uniandes', 'T3_DE_Karlsruhe', 'T3_ES_Oviedo', 'T3_FR_IPNL', 'T3_GR_Demokritos', 'T3_GR_IASA',
                  'T3_GR_Ioannina', 'T3_IT_Napoli', 'T3_IT_Perugia', 'T3_IT_Trieste', 'T3_TW_NCU', 'T3_UK_SGrid_Oxford', 'T3_US_Colorado',
                   'T3_US_Cornell', 'T3_US_FNALLPC', 'T3_US_Kansas', 'T3_US_Minnesota', 'T3_US_Princeton', 'T3_US_Rice', 'T3_US_Rutgers',
                    'T3_US_TTU', 'T3_US_UCLA', 'T3_US_UCR', 'T3_US_UIowa', 'T3_US_UMD', 'T3_US_Vanderbilt')

  national={'CH':'Switzerland','DE':'Germany','ES':'Spain','IT':'Italy','TW':'Taiwan','UK':'United Kingdom','US':'United States','AT':'Austria','BE':'Belgium','BR':'Brazil','CN':'China','EE':'Estonia','FI':'Finland','HU':'Hungary','IN':'India','KR':'Korea','PK':'Pakistan','PL':'Poland','PT':'Portugal','RU':'Russia','TR':'Turkey','UA':'Ukraine','CO':'Colombia','GR':'Greece'}
  regional={}
  groups={}
  groups['site']={'tier':'Tier','country':'Country','region':'Region','tiercountry':'Tier, Country','tierregion':'Tier, Region','top5site':'Top 5 Sites'}
  groups['wf']={'1':'Primary','2':'Secondary','3':'Tertiary','top5wf':'Top 5 Workflows'}
  def __init__(self,server,*args):
    socket.setdefaulttimeout(30)
    self.cache = ProdmonCache()
    engine.on_stop_engine_list.append(self.cache.stop)
    self.cache.start()
  def plot(self,*path,**attrs):
    """
    Landing function for plotfairy requests.
    Format in *path should be what/sortby/plot/jobtype/datatype?starttime=XXX&endtime=...
    *path arguments are mandatory and this function should fail and return None,None if they are not found.
    **kwargs are all optional, defaults are provided in all cases.
    This function formats the query into a ProdmonQuery object, then passes it to GetPlotFromQuery.
    Defaults for missing keyword args are 48h plot, png image 800x600@72dpi (although these defaults are applied within ProdmonQuery)
    
    Also handles summary plots with paths of the form summary/{site,wf}/{plot,legend,map}
    An appropriate query object is created for these and then they are generated by the normal code path.
    """
    if len(path) == 3:
      if path[0] in ('summary') and path[1] in ('site','wf') and path[2] in ('plot','legend','map','plot+legend'): # Deprecated table output, now handled in state
        resulttype=path[2]
        #if resulttype == 'table':
        #  if path[1] =='site':
        #    return #'text/plain',self._cacheFetch('PA_SITESUMMARYTABLE',self._summaryTable,'site')
        #  elif path[1]=='wf':
        #    return 'text/plain',self._cacheFetch('PA_WFSUMMARYTABLE',self._summaryTable,'wf')
        #  else:
        #    return None,None # Type of table we don't understand
        #else: # We've already established this is a valid choice (plot,legend,map)
        if path[1] == 'site':
          query = ProdmonQuery('evts_read_any','site','pie','Any',type='png',width='400',height='200',group='top5site')
        elif path[1] == 'wf':
          query = ProdmonQuery('evts_read_any','wf','pie','Any',type='png',width='400',height='200',group='top5wf')
        else:
          return None,None # Type of plot we don't understand
        return self._getPlotFromQuery(query,resulttype)
    
    if len(path) == 5:
      query = ProdmonQuery(*path,**attrs)
      resulttype=path[4]
      return self._getPlotFromQuery(query,resulttype)
    
    return None,None # Fall through if the path length didn't match 3 or 5, or the summary format was inconsistent

  def _getPlotFromQuery(self,query,resulttype):
    """
    GetPlotFromQuery evaluates a query object, testing it for validity before using the cache access functions to return the data.
    """
    if not (resulttype in ('plot','legend','map','plot+legend') or (query['plot']=='data' and resulttype=='table')):
      print "PS: Unknown or inconsistent result type [%s]" % (resulttype)
      return None,None
    if not query.isValid():
      print "PS: Query invalid"
      return None,None
    
    plot = query['plot']
    if plot=='data':
      #return self._plotData(resulttype,query)
      return 'text/html',self._cacheFetch(query.cacheKey('PA_TABLE'),self._plotData,query)
    if not plot in ('pie','bar','cumulative'):
      print "PS: Unknown plot types [%s]" % (plot)
      return None,None
    
    plotdata = self._cacheFetchWithLock(query.cacheKey('PA_PLOT'),self._plotMaker,query)
    if resulttype=='plot':
      return ProdmonSource.types[query['type']],plotdata[0]
    elif resulttype=='legend':
      return ProdmonSource.types[query['type']],plotdata[1]
    elif resulttype=='map':
      return 'text/plain',plotdata[2]
    elif resulttype=='plot+legend':
      #return ProdmonSource.types[query['type']],stitchPlotAndLegend(plotdata[0],plotdata[1])
      return ProdmonSource.types[query['type']],plotdata[3]
    else:
      pass # Already validated that we have one of the above
  
  def _plotMaker(self,query):
    """
    PlotMaker is a cache maker function which returns the appropriate plot,legend,map tuple if they aren't found in cache.
    """
    plot = query['plot']
    if plot=='pie':
      plotdata = self._plotPie(query)
    elif plot=='bar':
      plotdata = self._plotBar(query)
    elif plot=='cumulative':
      plotdata = self._plotCumulative(query)
    else:
      pass # Plot type validity has already been checked
    #if query['type']=='png':
    plotdata = plotdata[0],plotdata[1],plotdata[2],stitchPlotAndLegend(plotdata[0],plotdata[1])
    #else:
      #plotdata = plotdata[0],plotdata[1],plotdata[2],''
    return plotdata,1800,sum([len(d) for d in plotdata])
      
  def _plotData(self,query):
    """
    PlotData makes a formatted HTML table from a query request (where the 'what' is data)
    """
    qresult = self._cacheFetchWithLock(query.cacheKey('PA_QUERY',False),self._getResult,query)
    result = "<table>"
    if len(qresult)>0:
      fields = qresult[0].keys()
      result+="<tr>"
      for f in fields:
        result+="<td>%s</td>" % (f)
      result+="</tr>\n"
      for item in qresult:
        result+="<tr>"
        for f in fields:
          result+="<td>%s</td>" % (item[f])
        result+="</tr>\n"
    result+="</table>\n"    
    return result,1800,len(result)
      
    
  def summaryList(self,which,n=5):
    if which=='site':
      return self._cacheFetch("PA_SITETOP%s"%(n),self._getSiteTop,n)
    elif which=='wf':
      return self._cacheFetch("PA_WFTOP%s"%(n),self._getWFTop,n)
    return None
  
  # Deprecated  
  #def _summaryTable(self,which):
  #  """
  #  SummaryTable makes a hyperlinked top 5 html table for the summary page (cache maker function).
  #  TODO: this should maybe be moved to being included in the workspace state functions to avoid unnecessary XHR requests.
  #  """
  #  if which=='site':
  #    top5 = self._cacheFetch("PA_SITETOP5",self._getSiteTop,5)
  #  elif which=='wf':
  #    top5 = self._cacheFetch("PA_WFTOP5",self._getWFTop,5)
  #  else:
  #    raise Exception, 'Unknown summary table type [%s]' % (which)
  #  result="<table>"
  #  for i,s in enumerate(top5):
      #result += """<tr><td>%d</td><td><a href='#' onclick='return GUI.Plugin.ProdmonGraphBase.handleMapClick("%s","%s")'>%s</a></td></tr>""" % (i+1,which,s,s)
  #  result += "</table>"
      
  #  return result,1800,len(result)
  

  def _getFilterGroup(self,query):
    filterer = lambda x: True
    if 'wfx' in query and not query['wfx']=='':
      filterer = self._regexFilter(query['wfx'])
    if 'sitex' in query and not query['sitex']=='':
      filterer = self._regexFilter(query['sitex'])
      
    if 'group' in query:
      if query['sortby']=='site':
        if query['group'] in ProdmonSource.groups['site']:
          group = self._groupSite(query['group'])

      if query['sortby']=='wf':
        if query['group'] in ProdmonSource.groups['wf']:
          group = self._groupWF(query['group'])
    else:
      group = lambda x: x
    return filterer,group

  def _plotPie(self,query):
        
    plotkey = query.cacheKey("PA_PLOT")
    result = self._cacheFetchWithLock(query.cacheKey('PA_QUERY',False),self._getResult,query)
    
    filterer,group = self._getFilterGroup(query)
    
    names=[]
    data={}
    
    # Only need to handle name,value for pie data, epoch not included
    for item in result:
      name = item['NAME']
      if filterer(name):
        value=float(item['VALUE'])
        if value>0.:
          name = group(name)
          if not name in names:
            names.append(name)
          if not name in data:
            data[name]=value
          else:
            data[name]+=value
    
    if query['type']=='json':
      json = "[%r]" % (data)
      return json,json,json
    
    legend = self._getLegend(names)
    
    plot = PieChart(data,legend,{
            'imageType':query['type'],
            'height':query['height'],
            'width':query['width'],
            'dpi':query['dpi'],
            'title': query.plotTitle(),
            'starttime':query._stampToTime(query['starttime']),
            'endtime':query._stampToTime(query['endtime']),
            'mapName':'mainplot',
            'map_href':'#',
            #'map_onmouseover':"return GUI.Plugin.ProdmonGraphBase.handleMapMouse('%s','$n','$v')" % query['sortby'],
            'map_onclick':"return GUI.Plugin.ProdmonGraphBase.handleMapClick('%s','$n')" % query['sortby'],
            'map_title':'$n: $v' # A note on tooltips. From Netscape 6, gecko based browsers ignore the alt-tag for tooltip and only use the title attribute. MSIE draws either, with alt taking precedence. HTML standard technically requires alt, but this will only increase map size. Including an onmouseover trigger suppresses either from displaying (this could be used for something more elaborate, eg YUI tooltips, but currently isn't).
            })
    imgdata,legenddata,mapdata = plot.make()
    return imgdata,legenddata,mapdata
  
  def _getSeries(self,result,interval):
    epochset=set()
    for item in result:
      epochset.add(int(item['EPOCH']))
    if len(epochset)>0:
      first = min(epochset)
      last = max(epochset)
      series = []
      now = first
      while (now<=last):
        series.append((now,now+interval))
        now += interval
      return series
    else:
      return None

  def _getLegend(self,names):
    colors = [ "#7D818C", "#007092", "#75B3CE", "#B40019", "#FFDC8C", "#F79025",
         "#BBBEC5", "#231F20", "#e66266", "#fff8a9", "#7bea81", "#8d4dff",
         "#ffbc71", "#a57e81", "#baceac", "#00ccff", "#ccffff", "#ff99cc",
         "#cc99ff", "#ffcc99", "#3366ff", "#33cccc", "#ffffff", "#bbbbbb",
         "#777777", "#333333" ]
    legend = []
    for i,n in enumerate(names):
      legend.append({'key':n,'name':n,'attrs':{'facecolor':colors[i % len(colors)]}})
    return legend
  
  def _plotBar(self,query):

    result = self._cacheFetchWithLock(query.cacheKey('PA_QUERY',False),self._getResult,query)
    
    filterer,group = self._getFilterGroup(query)  
    
    #series - ((start,end),(start2,end2)...)
    #data - ({name:value,name2:value2},{...},...)
    span,interval = query.getInterval()
    series=self._getSeries(result,interval)
    
    if series:
    
      names=[]
      epochindex={}
      data=[]
      for i,s in enumerate(series):
        epochindex[s[0]]=i
        data.append({})
    
      for item in result:
        name = item['NAME']
        if filterer(name):
          epoch = int(item['EPOCH'])
          value = float(item['VALUE'])
          if value>0.:
            name = group(name)
            if not name in names:
              names.append(name)
            if not name in data[epochindex[epoch]]:
              data[epochindex[epoch]][name]=value
            else:
              data[epochindex[epoch]][name]+=value
    
      #this is an ugly hack to ensure there is a data item known to the legend in each epoch
      #otherwise we get a daft blank graph
      if len(names)>=1:
        for d in data:
          if len(d)==0:
            d[names[0]]=0
    
    else:
      starttime = query._stampToTime(query['starttime'])
      endtime = query._stampToTime(query['endtime'])
      periods = int((endtime-starttime)/interval)
      series = [(starttime+n*interval,starttime+(n+1)*interval) for n in range(periods)]
      data=[{} for n in range(periods)]
      names=[]
    
    if query['type']=='json':
      json = "[%r,%r]" % (series,data)
      return json,json,json
    
    legend = self._getLegend(names)
    
    plot = TimeSeriesBarChart(span, series, data, legend, {
                  'imageType':query['type'],
                  'height':query['height'],
                  'width':query['width'],
                  'dpi':query['dpi'],
                  'title': query.plotTitle(),
                  'yAxisTitle': ProdmonSource.params['what'][query['what']],
                  'mapName':'mainplot',
                  'map_href':'#',
                  'map_title':'$n: $v for $b-$e',
                  'map_onclick':"return GUI.Plugin.ProdmonGraphBase.handleMapClick('%s','$n')" % query['sortby']
                  #'map_onmouseover':"return GUI.Plugin.ProdmonGraphBase.handleMapMouse('%s','$n','$v')" % query['sortby']
                  })
    imgdata,legenddata,mapdata = plot.make()
    return imgdata,legenddata,mapdata
    
  
  def _plotCumulative(self,query):
    
    result = self._cacheFetchWithLock(query.cacheKey('PA_QUERY',False),self._getResult,query)
    
    filterer,group = self._getFilterGroup(query)  
    
    #series - ((start,end),(start2,end2)...)
    #data - ({name:value,name2:value2},{...},...)
    span,interval = query.getInterval()
    series=self._getSeries(result,interval)
    
    if series:  
      names=[]
      epochindex={}
      data=[]
      for i,s in enumerate(series):
        epochindex[s[0]]=i
        data.append({})
    
      for item in result:
        name = item['NAME']
        if filterer(name):
          epoch = int(item['EPOCH'])
          value = float(item['VALUE'])
          if value>0.:
            name = group(name)
            if not name in names:
              names.append(name)
            if not name in data[epochindex[epoch]]:
              data[epochindex[epoch]][name]=value
            else:
              data[epochindex[epoch]][name]+=value
    
      #this is an ugly hack to ensure there is a data item known to the legend in each epoch
      #otherwise we get a daft blank graph
      #who knows why?
      if len(names)>=1:
        for d in data:
          if len(d)==0:
            d[names[0]]=0
    
    else:
      starttime = query._stampToTime(query['starttime'])
      endtime = query._stampToTime(query['endtime'])
      periods = int((endtime-starttime)/interval)
      series = [(starttime+n*interval,starttime+(n+1)*interval) for n in range(periods)]
      data=[{} for n in range(periods)]
      names=[]
    
    if query['type']=='json':
      json = "[%r,%r]" % (series,data)
      return json,json,json
    
    legend = self._getLegend(names)
    
    plot = CumulativeTimeSeriesChart(span, series, data, legend, {
                  'imageType':query['type'],
                  'height':query['height'],
                  'width':query['width'],
                  'dpi':query['dpi'],
                  'title': query.plotTitle(),
                  'yAxisTitle': ProdmonSource.params['what'][query['what']],
                  'mapName':'mainplot',
                  'map_href':'#',
                  'map_title':'$n: $v',
                  'map_onclick':"return GUI.Plugin.ProdmonGraphBase.handleMapClick('%s','$n')" % query['sortby']
                  #'map_onmouseover':"return GUI.Plugin.ProdmonGraphBase.handleMapMouse('%s','$n','$v')" % query['sortby']
                  })
    imgdata,legenddata,mapdata = plot.make()
    return imgdata,legenddata,mapdata
    
    
  def _cacheFetchWithLock(self,cachekey,f_produce,*args,**kwargs):
    """
    Extended version of the _cacheFetch function that also locks the relevant key before fetching anything.
    """
    self.cache.keylock_acquire(cachekey)
    try:
      return self._cacheFetch(cachekey,f_produce,*args,**kwargs)
    finally:
      self.cache.keylock_release(cachekey)

  def _cacheFetch(self,cachekey,f_produce,*args,**kwargs):
    """
    Wrapper function to perform the fetch-from-cache-or-produce logic that was otherwise duplicated frequently.
    *args and **kwargs are passed to the f_produce function, which should be a callable that returns (data,lifetime,datasize)
    """
    if cachekey in self.cache:
      cachedata = self.cache[cachekey]
    else:
      cachedata,lifetime,size = f_produce(*args,**kwargs)
      self.cache.insert(cachekey,lifetime,size,cachedata)
    return cachedata
  
  def _getResult(self,query):
    """
    GetResult is a cachemaker function which actually gets data from the backend. HTTP errors are not actually handled here (logged and re-raised) since we don't want dead data to get cached - better to end up with HTTP 500 instead
    """
    urlquery = query.getURL()
    try:
      data = urllib2.urlopen("%s%s" % (ProdmonSource.url,urlquery)).read()
    except IOError:
      print "PS: Error occurred during data fetching"
      raise # Re-raise the error
    if ("Exception" in data.split("\n",1)[0]):
      raise IOError, "Dashboard returned error %s in query %s" % (data.split("\n",1)[0],self.urlquery)
    result = ProdmonQueryResult(data)
    return result,1200,result.size()
    

  def getSiteList(self,sitefilter=None):
    """
    Get an optionally-filtered list of sites. Currently from a flat hardcode list.
    """
    return filter(sitefilter,ProdmonSource.sitelist)
  
  def _getWFList(self):
    """
    Get the list of all known workflows from the wf_summary table.
    Updated _getWFList for use with _fetchCache
    """
    query = ProdmonQuery('wf_summary','wf','data','Any')
    qresult = self._cacheFetchWithLock(query.cacheKey('PA_QUERY',False),self._getResult,query)
    result = []
    for item in qresult:
      result.append(copy(item['WORKFLOW'].encode('ascii')))
    size = 0
    for item in result:
      size += len(item)
    return result,1800,size
    
  def getAllWFSummary(self):
    return self._cacheFetch('PA_WFSUMMARY',self._getWFSummary)
    
  def getWFSummary(self,wf):
    table = self._cacheFetch('PA_WFSUMMARY',self._getWFSummary)
    return table[wf]
    
  def getStatsSummary(self):
    table = self._cacheFetch('PA_WFSUMMARY',self._getWFSummary)
    result = {}
    result['workflow_count']=len(table)
    result['total_unmerged']=0
    result['total_merged']=0
    time_per_event = []
    for t in table:
      result['total_unmerged']+=int(table[t]['UNMERGED_EVTS'])
      result['total_merged']+=int(table[t]['MERGED_EVTS'])
      time_per_event.append(float(table[t]['TIME_PER_EVENT']))
    result['avg_time_per_event']=sum(time_per_event)/len(time_per_event)
    result['min_time_per_event']=min(time_per_event)
    result['max_time_per_event']=max(time_per_event)
    return result
  
  def _getWFSummary(self):
    """
    GetWFSummary fetches the special-case wf summary table, and parses it into a dictionary.
    """
    query = ProdmonQuery('wf_summary','wf','data','Any')
    qresult = self._cacheFetchWithLock(query.cacheKey('PA_QUERY',False),self._getResult,query)
    result = {}
    for item in qresult:
      itemresult={}
      wf = copy(item['WORKFLOW'])
      for attrib in item:
        itemresult[attrib] = copy(item[attrib])
      result[wf]=itemresult
    size = 0
    for wf in result:
      for attrib in result[wf]:
        size += len(result[wf][attrib])
    return result,1800,size
  
  def _getWFTop(self,count,sortkey='MERGED_EVTS'):
    wfsummary = self._cacheFetch('PA_WFSUMMARY',self._getWFSummary)
    
    wflist = wfsummary.keys()
    wflist.sort(key=lambda x: int(wfsummary[x][sortkey]))
    wflist.reverse()
    wflist = wflist[0:count]
    size = 0
    for wf in wflist:
      size+=len(wf)
    return wflist,1800,size
  
  def _getSiteTop(self,count):
    query = ProdmonQuery('evts_read_any','site','pie','Any')
    result = self._cacheFetchWithLock(query.cacheKey('PA_QUERY',False),self._getResult,query)
    
    sites = [(item['NAME'],int(item['VALUE'])) for item in result]
    sites.sort(key=lambda x: x[1])
    sites.reverse()
    
    sitelist = [s[0] for s in sites[0:count]]
    
    size=0
    for site in sitelist:
      size+=len(site)
    return sitelist,1800,size
  
  def getWFList(self,wffilter=None):
    if not wffilter:
      wffilter = lambda x: True
    wflist = self._cacheFetch("PA_WFLIST",self._getWFList)
    return filter(wffilter,wflist)

                
  def prepareSession(self,session):
    """
    Prepare when a new session hits the server. We don't handle sessions in the source, so do nothing.
    """
    pass
  
  def _regexFilter(self,regex):
    class _re_filter:
      def __init__(self,regex):
        try:
          self.regex = re.compile(regex)
        except re.error:
          self.regex = None
      def __call__(self,x):
        if self.regex:
          try:
            return self.regex.search(x)!=None
          except re.error:
            return False
        return False
    return _re_filter(regex)
          
    
  def _groupSite(self,mode):
    """
    GroupSite is a factory method that returns a callable() object which groups site names according to the selected mode.
    
    TODO: Regional doesn't work yet.
    TODO: Many of these functions should be delegated to sitedbsource.
    """
    
    class site_grouper:
      
      grouping={}
      grouping['tier']=lambda x: x.split('_')[0]
      grouping['country']=lambda x: self.national.get(x.split('_')[1],x.split('_')[1])
      grouping['tiercountry']=lambda x: "%s %s" % (x.split('_')[0], self.national.get(x.split('_')[1],x.split('_')[1]))
      grouping['region']=lambda x: self.regional.get(x.split('_')[1],x.split('_')[1])
      grouping['tierregion']=lambda x: self.regional.get(x.split('_')[1],x.split('_')[1])
      def __init__(self,mode):
        self.function = self.grouping[mode]
      def __call__(self,site):
        try:
          return self.function(site)
        except IndexError:
          return site
    
    class top5_group_site:
      def __init__(self,toplist):
        self.toplist=toplist
      def __call__(self,site):
        if site in self.toplist:
          return site
        else:
          return 'Other'
    
    if not mode in ProdmonSource.groups['site']:
      raise Exception, 'Unknown site grouping mode: %s' % (mode)
    if mode in site_grouper.grouping:
      return site_grouper(mode)
    else:
      if mode=='top5site':
        return top5_group_site(self._cacheFetch("PA_SITETOP5",self._getSiteTop,5))
    return lambda x: x
      

  def _groupWF(self,mode):
    """
    GroupWF is a factory method that returns a callable for workflow grouping.
    """
    class count_group_wf:
      separator='-'
      def __init__(self,count):
        self.count = count
      def __call__(self,wf):
        if wf.count(self.seperator)>=self.count:
          parts = wf.split(separator)
          return separator.join(parts[0:self.count])
        else:
          return wf
    class top5_group_wf:
      def __init__(self,toplist):
        self.toplist=toplist
      def __call__(self,wf):
        if wf in self.toplist:
          return wf
        else:
          return 'Other'
    
    if not mode in ProdmonSource.groups['wf']:
      raise Exception, 'Unknown workflow grouping mode: %s' % (mode)
    if mode.isdigit():
      mode = int(mode)
      return count_group_wf(mode)
    else:
      if mode=='top5wf':
        return top5_group_wf(self._cacheFetch("PA_WFTOP5",self._getWFTop,5))
    return lambda x: x

class ProdmonQuery:
  """
  Wrapper class for a query to the backend system. Turns it into a query string, adds timestamps if none exists and checks for validity.
  """
  timedelta = 1800 #all time variables are set to previous 30 minute interval, to make them cacheable (a request for 12:47:19 is converted to 12:30:00 etc)
  def __init__(self,*path,**attrs):
    """
    Create a new Query from the path (as passed to ProdmonSource.plot) and attributes (from which we're only interested in time keys).
    Time variables are rounded to the nearest timedelta (30 minutes) - data isn't available at shorter timespans than this and otherwise no data is going to get cached.
    """
    self.query = {'what':path[0], 'sortby':path[1],'plot':path[2],'job_type':path[3]}
    #if no endtime is set, set it to now (with timedelta)
    if 'endtime' in attrs:
      endtime=self._stampToTime(attrs['endtime'])
    else:
      endtime=time.time()
    endtime = endtime - (endtime % ProdmonQuery.timedelta)
    self.query['endtime']=self._timeToStamp(endtime)
    #if no starttime is set, make it endtime-48h
    if 'starttime' in attrs:
      starttime=self._stampToTime(attrs['starttime'])
    else:
      starttime = time.time()-172800 #48h
    starttime = starttime - (starttime % ProdmonQuery.timedelta)
    self.query['starttime']=self._timeToStamp(starttime)
    #these are known parameters which need to be considered in the plot cache key
    for s in ('site','sitex','wf','wfx','group','width','height','dpi','type'):
      if s in attrs and not (attrs[s]=='' or attrs[s]=='null'):
        self.query[s]=copy(attrs[s])
    
    #set some defaults for optional image arguments
    if not 'height' in self.query:
      self.query['height']='600'
    if not 'width' in self.query:
      self.query['width']='800'
    if not 'dpi' in self.query:
      self.query['dpi']='72'
    if not 'type' in self.query:
      self.query['type']='png'
    else:
      if not self.query['type'] in ProdmonSource.types:
        self.query['type']='png'
    
    
  def getURL(self):
    """
    Return the query encoded to a url, ready to be appended to the source URL+?
    """
    #parameters understood by PAQuery
    urlparam=('what','sortby','plot','job_type','starttime','endtime','span','site','wf','dts','prod_team')
    tocode={}
    for up in urlparam:
      if up in self.query:
        tocode[up]=self.query[up]
    return urllib.urlencode(tocode)
    
  def isValid(self):
    """
    Test if the query is valid. Tests that all the mandatory parameters are filled (or the wf_summary special case), and that the start and end times are properly set and in the correct order.
    """
    
    matched = 0
    for key in self.query:
      if key in ProdmonSource.params:
        if self.query[key] in ProdmonSource.params[key]:
          matched += 1
    if matched==4 or (matched==2 and self.query['what']=='wf_summary' and self.query['plot']=='data'):
      if 'starttime' in self.query and 'endtime' in self.query:
        try:
          starttime = self._stampToTime(self.query['starttime'])
          endtime = self._stampToTime(self.query['endtime'])
        except ValueError:
          return False
        if starttime<=endtime and endtime<=time.time():
          return True
      else:
        return False
    else:
      return False
      
  def cacheKey(self,prefix='',full=True):
    """
    Return this query as a key to use for the backing cache.
    
    Two forms available - short key containing just the query parameters (full=False) for use in caching the query, and the long form (full=True) containing the image parameters and post-query options like regexes.
    """
    base = "%s|%s|%s|%s|%s|%s" % (self.query['what'],self.query['sortby'],self.query['plot'],self.query['job_type'],self.query['starttime'],self.query['endtime'])
    image=""
    if 'width' in self.query and 'height' in self.query and 'dpi' in self.query and 'type' in self.query:
      image = "|%s|%sx%sx%s" % (self['type'],self['width'],self['height'],self['dpi'])
    extra = ""
    if 'wf' in self.query:
      base += "|wf:%s" % (self['wf'])
    if 'wfx' in self.query:
      extra += "|wfx:%s" % (self['wfx'])
    if 'site' in self.query:
      base += "|site:%s" % (self['site'])
    if 'sitex' in self.query:
      extra += "|sitex:%s" % (self['sitex'])
    if 'group' in self.query:
      extra += "|group:%s" % (self['group'])
    if full:
      return "%s@%s%s%s" % (prefix,base,image,extra)
    else:
      return "%s@%s" % (prefix,base)
  
  
  def _timeToStamp(self,time):
    """
    Convert a seconds since epoch time number into the query timestamp format.
    TODO: check timezone behaviour of this
    """
    dt = datetime.datetime.fromtimestamp(time)
    return "%s-%s-%s %s:%s:%s" % (dt.year,dt.month,dt.day,dt.hour,dt.minute,dt.second)
  def _stampToTime(self,stamp):
    """
    Convert a query timestamp into seconds since the epoch.
    TODO: check timezone behaviour of this
    """
    ts = time.mktime(time.strptime(stamp,"%Y-%m-%d %H:%M:%S"))
    return ts
  def __getitem__(self,key):
    """
    Direct access to the query keys. Don't you just love python operator overriding?
    """
    return self.query[key]
  
  def plotTitle(self):
    """
    Get a formatted plot title based on this query.
    """
    start = "%s (%s jobs)," % (ProdmonSource.params['what'][self['what']],ProdmonSource.params['job_type'][self['job_type']])
    sort = "sorted by %s" % (ProdmonSource.params['sortby'][self['sortby']])
    group = ""
    if 'group' in self.query and self['sortby']=='site':
      group = "grouped by %s" % (ProdmonSource.groups['site'][self['group']])
    if 'group' in self.query and self['sortby']=='wf':
      group = "grouped by %s" % (ProdmonSource.groups['wf'][self['group']])
    if 'site' in self.query:
      return "%s for site %s" % (start,self['site'])
    if 'wf' in self.query:
      return "%s for workflow %s" % (start,self['wf'])
    if 'sitex' in self.query and not self['sitex']=='*':
      return "%s for sites matching %s, %s" % (start,self['sitex'],sort)
    if 'wfx' in self.query and not self['wfx']=='*':
      return "%s for workflows matching %s, %s" % (start,self['wfx'],sort)
    return "%s %s" % (start,sort)
  
  def getInterval(self):
    """
    Get the time binning interval for this data. This should probably be done by examination of the data,
    but as it currently stands short of compiling a histogram this is impossible and it will instead be
    inferred on the basis of 1-day intervals for >168 hours and 1-hour intervals otherwise
    """
    start = self._stampToTime(self['starttime'])
    end = self._stampToTime(self['endtime'])
    if end-start >= 604800:
      return 'day',86400
    else:
      return 'hour',3600
    
    
  
  def __iter__(self):
    return self.query.__iter__()

  
class ProdmonQueryResult:
  """
  Parses the raw data from an xml request (using DOM) and provides an iterator over the items it returns.
  """
  def __init__(self,data):
    """
    Create a new Query result from raw XML data
    """
    dom = parseString(data)
    self.items=[]
    for item in dom.getElementsByTagName("item"):
      result={}
      for c in item.childNodes:
        tagname = copy(c.tagName)
        if c.firstChild:
          child = copy(c.firstChild.nodeValue.encode('ascii'))
          result[tagname]=child
        else:
          result[tagname]=''
      self.items.append(result)
    dom.unlink()
    
  def size(self):
    size=0
    for item in self.items:
      for k,v in item.iteritems():
        size+=len(k)
        size+=len(v)
    return size
  
  def __getitem__(self,i):
    """
    Get an indexed item, returning a dictionary of the named sub-keys and their values.
    """
    return self.items[i]
  def __iter__(self):
    """
    Return a QueryIterator over this result.
    """
    return self.items.__iter__()
  def __len__(self):
    """
    Get the number of items this result contains.
    """
    return len(self.items)
        
  
class ProdmonCache(Thread):
  """
  Thread-watched cache of data for prodmon (or anything else)
  All non _-prefixed methods should be thread-safe for external calling
  """
  
  #synchronized function decorator. use?
  #@synchronized(self.lock)
  def synchronized(lock):
    def wrap(f):
      def inner_wrap(*args,**kwargs):
        lock.acquire()
        try:
          return f(*args,**kwargs)
        finally:
          lock.release()
      return inner_wrap
    return wrap
  
  def __init__(self,interval=10,cachelimit=10000000):
    """
    Create a new ProdmonCache. Note that it is not started until the .start() method is called.
    
    @param interval: interval in seconds between the main loop running (30)
    @param cachesize: maximum size in bytes before old entries start getting culled. Note that this is done *imprecisely* and will not be strictly adhered to! (10MB)
    """
    Thread.__init__(self,name="ProdmonCache")
    self.lock = Lock()
    self.stopme = False
    self.cachesize = 0
    self.cache = {} # objkey: tuple (expiry, size, data)
    self.interval = interval
    self.cachelimit = cachelimit
    self.cachelocks = {} #objkey: tuple(expiry,data)
    
  def stop(self):
    """
    When called, causes the thread to exit, the next time the main loop runs.
    """
    self.lock.acquire()
    #print "PC: setting exit flag"
    self.stopme = True
    self.lock.release()
    
  def run(self):
    while True:
      self.lock.acquire()
      #print "PC: Main loop runs. %s items in cache using %s bytes." % (len(self.cache),self.cachesize)
      if self.stopme:
        #print "PC: Main loop exiting"
        return
      self._clean_expired()
      self.lock.release()
      time.sleep(self.interval)
  def _expiry_dict(self,cachedict):
    """
    Return a dictionary of of {expiry: [objkeys]}. Intended for internal use so no locking is performed!
    """
    result = {}
    for objkey in cachedict:
      expiry = self.cache[objkey][0]
      if expiry in result:
        result[expiry].append(objkey)
      else:
        result[expiry]=[]
        result[expiry].append(objkey)
    return result
  
#  def _size_dict(self):
#    """
#    Return a dictionary of of {datasize: objkey}. Intended for internal use so no locking is performed!
#    """
#    result = {}
#    for objkey in self.cache.keys():
#      size = self.cache[objkey][1]
#      if size in result:
#        result[size].append(objkey)
#      else:
#        result[size]=[]
#        result[size].append(objkey)
#    return result
    
  def _clean_expired(self):
    """
    Iterate through the cache, removing any keys for which the current time is later than the expiry time.
    Assumes that it will only be called from a function that has already acquired a lock.
    """
    
    now = time.time()
    exp_lockkeys=[]
    for lockkey in self.cachelocks:
      exp = self.cachelocks[lockkey][0]
      if exp<now:
        exp_lockkeys.append(lockkey)
    for l in exp_lockkeys:
      del self.cachelocks[l] # Deleting a Lock appears to release it. Is this always true?
        
    exp_keys=[]
    for objkey in self.cache:
      exp = self.cache[objkey][0]
      if exp<now:
        exp_keys.append(objkey)
    
    for k in exp_keys:
      self._remove(k)
  
  def keylock_acquire(self,key,expiry=60):
    lock=None
    self.lock.acquire()
    try:
      if key in self.cachelocks:
        lock=self.cachelocks[key][1]
      else:
        lock=Lock()
        self.cachelocks[key]=(expiry+time.time(),lock)
    finally:
      self.lock.release()
    #release global lock, acquire local lock
    lock.acquire()
  
  def keylock_release(self,key):
    lock=None
    self.lock.acquire()
    try:
      if key in self.cachelocks:
        lock=self.cachelocks[key][1]
    finally:
      self.lock.release()
    #release global lock, release local lock
    if lock:
      lock.release()

  def keylock_get(self,key):
    lock=None
    self.lock.acquire()
    try:
      if key in self.cachelocks:
        lock=self.cachelocks[key][1]
    finally:
      self.lock.release()
    #release global lock, release local lock
    return lock
      
  
  def _clean_volume(self,volume):
    """
    Iterate through the cache, removing keys in expiry order to try and recover volume space (or empty the cache completely).
    Assumes that it will only be called from a function that has already acquired a lock.
    @param volume: target volume to remove. 
    """
    #"PC: Cleaning volume [%s]" % (volume)
    cleaned = 0
    expiry_dict = self._expiry_dict()
    expiry_list = sorted(expiry_dict.keys())
    while cleaned<=volume and len(expiry_list)>=0:
      expiry_time = expiry_dict[expiry_list.pop(0)]
      for key in expiry_dict[expiry_time]:
        cleaned += self._remove(key)
        if cleaned>=volume:
          break
      #print "PC: Deleted key [%s], recovered total [%s]" % (expiry_key,cleaned)
    
  
  def _insert(self,key,lifetime,size,data,withlock):
    #print "PC: Inserting key [%s], lifetime: %s, size: %s" % (key,lifetime,size)
    if self._exists(key):
      self._remove(key)
    self.cache[key]=(lifetime+time.time(),size,data)
    self.cachesize+=size
    if self.cachesize>=self.cachelimit:
      #print "PC: New insertion exceeds cache limit [%s/%s]" % (self.cachesize,self.cachelimit)
      self._clean_volume(self.cachesize-self.cachelimit)
    #print "PC: Insertion complete"
  
  def insert(self,key,lifetime,size,data,withlock=False):
    """
    Insert a new key into the cache, with associated expiry lifetime, size and data. Triggers volume cleaning if the new cache size exceeds the maximum.
    @param key: key for the new data - should be a string
    @param lifetime: desired cache lifetime of this object in seconds
    @param size: amount of space this object requires (since we can't trivially find this at insertion time, but at download or image creation time this may be better known)
    @param data: free data object. Preferably doesn't refer to other objects in the cache, or size calculations will become impossible.
    @param withlock: if you want a lock to be associated with this object
    """
    
    self.lock.acquire()
    try:
      self._insert(key,lifetime,size,data,withlock)
    finally:
      self.lock.release()
    
  
  def _remove(self,key):
    #print "PC: Removing key [%s]" % (key)
    size=-1
    if self._exists(key):
      size = self.cache[key][1]
      self.cachesize-=size
      del self.cache[key]
    return size
  
  def remove(self,key):
    """
    Remove a key from the cache, returning the freed space. Returns -1 if the key wasn't found (or if you set the key size to -1, which would be stupid.
    @param key: cache key to remove
    """
    
    self.lock.acquire()
    try:
      size = self._remove(key)
    finally:
      self.lock.release()
    return size
  
  def retrieve(self,key,default=None):
    """
    Attempts to retrieve the data associated with a key from the cache. Returns default (None) if not found.
    @param key: cache key to retrieve data for
    @param default: what to return if the key is not in the cache (None)
    """
    #print "PC: Getting key [%s]" % (key)
    self.lock.acquire()
    try:
      if self._exists(key):
        result = self.cache[key][2]
      else:
        #print "PC: Key [%s] not in cache" % (key)
        result= default
    finally:
      self.lock.release()
    return result
  
  def _exists(self,key):
    return key in self.cache
  
  def exists(self,key):
    result=False
    self.lock.acquire()
    try:
      result = self._exists(key)
    finally:
      self.lock.release()
    #print "PC: Testing key existence [%s], %s" % (key,result)
    return result
    
  def _expire(self,key):
    """
    Symonym for remove
    """
    return self.remove(key)
  
  def cachesize(self):
    """
    Get the current "size" of the cache
    """
    self.lock.acquire()
    try:
      result =  self.cachesize
    finally:
      self.lock.release()
    return result
    
  def cachelimit(self):
    """
    Get the sizelimit of the cache
    """
    self.lock.acquire()
    try:
      result= self.cachelimit
    finally:
      self.lock.release()
    return result
    
  def itemcount(self):
    """
    Get the number of items in the cache
    """
    self.lock.acquire()
    try:
      result= len(self.cache)
    finally:
      self.lock.release()
    return result
  
  def keylist(self):
    """
    Get a shallow-copied list of the keys in the cache
    """
    self.lock.acquire()
    try:
      result = self.cache.keys()
    finally:
      self.lock.release()
    return result
    
  def __getitem__(self,key):
    return self.retrieve(key)
  
  def __delitem__(self,key):
    return self.remove(key)
  
  def __len__(self):
    return self.itemcount()
  
  def __iter__(self):
    return self.keylist().__iter__()
  
  def __contains__(self,key):
    return self.exists(key)
  
#if __name__ == "__main__":
#  pc = ProdmonCache(10,100000)
#  for i in range(1000):
#    pc.insert(str(i),random.randint(1,300),random.randint(1,100),None)
#  pc.start()
