#include "VisMonitoring/DQMServer/interface/DQMRenderPlugin.h"
#include "VisMonitoring/DQMServer/interface/DQMRenderPluginDB.h"
#include "TCanvas.h"
#include "TText.h"
#include "TColor.h"
#include <cstring>

class TestDQMRenderPlugin : public DQMRenderPlugin
{
public:
  virtual bool applies (const DQMNet::CoreObject &o, const VisDQMImgInfo &)
  {
    return strncmp (o.name.c_str(), "YourSubsystemName/", 18) == 0;
  }

  virtual void preDraw (TCanvas *c, const DQMNet::CoreObject &,
			const VisDQMImgInfo &, VisDQMRenderInfo &)
  {
    c->SetFrameFillColor(TColor::GetColor(255, 255, 224));
  }

  virtual void postDraw (TCanvas *c, const DQMNet::CoreObject &, const VisDQMImgInfo &)
  {
    TText *t = new TText (.5, .25, "This is a test");
    t->SetNDC(kTRUE);
    t->SetTextFont(63);
    t->SetTextSize(16);
    t->SetTextAlign(22);
    t->SetTextColor(TColor::GetColor(255, 124, 124));
    t->Draw();
  }
};

DEFINE_IGUANA_MODULE();
DEFINE_IGUANA_PLUGIN(DQMRenderPluginDB, TestDQMRenderPlugin, "Test");
